.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

NULL EQU 0

.CODE
;---------------------------------------
CompareQwordsUnsigned PROC USES esi edi pqw1:PTR QWORD, pqw2:PTR QWORD
    ;------------------------------------------------
    ; Unsigned compare
    ;------------------------------------------------
    ; Returns 0 if qw1 == qw2
    ;         1 if qw1 >  qw2
    ;        -1 if qw1 <  qw2
    ;        -2 if error
    ;------------------------------------------------
    
    .IF (pqw1 == NULL) || (pqw2 == NULL)
        mov eax, -2
        jmp done
    .ENDIF    
            
    mov esi, pqw1
    mov edi, pqw2
    
    mov eax, DWORD PTR [esi+4]
    cmp eax, DWORD PTR [edi+4]
    ja  IsGreater
    jb  IsLessThan
    ; je fall through
    
    mov eax, DWORD PTR [esi+0]
    cmp eax, DWORD PTR [edi+0]
    ja  IsGreater
    jb  IsLessThan
    ; je fall through
    
  IsEqual:
    mov eax, 0
    jmp done

  IsLessThan:
    mov eax, -1
    jmp done

  IsGreater:
    mov eax, 1
    
  done:
    ret
    
CompareQwordsUnsigned ENDP

END
